Index: arch/sh/kernel/hd64465_gpio.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/hd64465_gpio.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/hd64465_gpio.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/hd64465_gpio.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: hd64465_gpio.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ * $Id: hd64465_gpio.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  * by Greg Banks <gbanks@pocketpenguins.com>
  * (c) 2000 PocketPenguins Inc
  *
Index: arch/sh/kernel/head.S
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/head.S,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/head.S	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/head.S	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: head.S,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: head.S,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  *  arch/sh/kernel/head.S
  *
@@ -50,12 +50,6 @@
 	sub	r1, r0		!
 	ldc	r0, r7_bank	! ... and init_task
 	!
-#if defined(__SH4__)
-	!                       Initialize fpu
-	mov.l   7f, r0
-	jsr     @r0
-	 nop
-#endif
 	!			Enable cache
 	mov.l	6f, r0
 	jsr	@r0
@@ -74,12 +68,9 @@
 	 nop
 
 	.balign 4
-1:	.long	0x400000F0		! MD=1, RB=0, BL=0, FD=0, IMASK=0xF
+1:	.long	0x400080F0		! MD=1, RB=0, BL=0, FD=1, IMASK=0xF
 2:	.long	SYMBOL_NAME(stack)
 3:	.long	SYMBOL_NAME(__bss_start)
 4:	.long	SYMBOL_NAME(_end)
 5:	.long	SYMBOL_NAME(start_kernel)
 6:	.long	SYMBOL_NAME(cache_init)
-#if defined(__SH4__)
-7:	.long   SYMBOL_NAME(fpu_init)
-#endif
Index: arch/sh/kernel/io_dc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/io_dc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/io_dc.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/io_dc.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: io_dc.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ *	$Id: io_dc.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *	I/O routines for SEGA Dreamcast
  */
 
Index: arch/sh/kernel/io_generic.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/io_generic.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/io_generic.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/io_generic.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: io_generic.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: io_generic.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  * linux/arch/sh/kernel/io_generic.c
  *
Index: arch/sh/kernel/io_hd64461.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/io_hd64461.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/io_hd64461.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/io_hd64461.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: io_hd64461.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ *	$Id: io_hd64461.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *	Copyright (C) 2000 YAEGASHI Takeshi
  *	Typical I/O routines for HD64461 system.
  */
Index: arch/sh/kernel/io_hd64465.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/io_hd64465.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/io_hd64465.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/io_hd64465.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: io_hd64465.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ * $Id: io_hd64465.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  * by Greg Banks <gbanks@pocketpenguins.com>
  * (c) 2000 PocketPenguins Inc
  *
Index: arch/sh/kernel/io_se.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/io_se.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/io_se.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/io_se.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: io_se.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: io_se.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  * linux/arch/sh/kernel/io_se.c
  *
@@ -23,6 +23,7 @@
 static inline void delay(void)
 {
 	ctrl_inw(0xa0000000);
+	ctrl_inw(0xa0000000);
 }
 
 /* MS7750 requires special versions of in*, out* routines, since
Index: arch/sh/kernel/irq.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/irq.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/irq.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/irq.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: irq.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: irq.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  * linux/arch/sh/kernel/irq.c
  *
@@ -246,7 +246,7 @@
 	   REPLAY is when Linux resends an IRQ that was dropped earlier
 	   WAITING is used by probe to mark irqs that are being tested
 	   */
-	status = desc->status & ~(IRQ_REPLAY | IRQ_WAITING);
+	status = desc->status & ~(IRQ_REPLAY | IRQ_WAITING | IRQ_INPROGRESS);
 	status |= IRQ_PENDING; /* we _want_ to handle it */
 
 	/*
Index: arch/sh/kernel/irq_imask.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/irq_imask.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/irq_imask.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/irq_imask.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: irq_imask.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: irq_imask.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  * linux/arch/sh/kernel/irq_imask.c
  *
Index: arch/sh/kernel/irq_intc2.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/irq_intc2.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/irq_intc2.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/irq_intc2.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -12,6 +12,8 @@
  * Hitachi 7751 and the STM ST40 STB1.
  */
 
+#include <linux/config.h>
+#include <linux/module.h>
 #include <linux/kernel.h>
 #include <linux/init.h>
 #include <linux/irq.h>
@@ -22,8 +24,11 @@
 
 
 struct intc2_data {
-	unsigned int addr;	/* Address of Interrupt Priority Register */
-	int mask; /*Mask to apply */
+	unsigned char msk_offset;
+	unsigned char msk_shift;
+#ifdef CONFIG_CPU_SUBTYPE_ST40
+	int (*clear_irq) (int);
+#endif
 };
 
 
@@ -56,33 +61,34 @@
 
 static void disable_intc2_irq(unsigned int irq)
 {
-	unsigned addr;
-	int offset=irq-INTC2_FIRST_IRQ;
-	unsigned val,flags;
+	int irq_offset = irq - INTC2_FIRST_IRQ;
+	int msk_shift, msk_offset;
 
 	// Sanity check
-	if(offset<0 || offset>=NR_INTC2_IRQS) return;
-
-	addr=intc2_data[offset].addr+INTC2_INTMSK_OFFSET;
+	if((irq_offset<0) || (irq_offset>=NR_INTC2_IRQS))
+		return;
 
-	save_and_cli(flags);
-	val=ctrl_inl(addr);
-	val|=intc2_data[offset].mask;
-	ctrl_outl(val,addr);
+	msk_shift = intc2_data[irq_offset].msk_shift;
+	msk_offset = intc2_data[irq_offset].msk_offset;
 
-	restore_flags(flags);
+	ctrl_outl(1<<msk_shift,
+		  INTC2_BASE+INTC2_INTMSK_OFFSET+msk_offset);
 }
 
 static void enable_intc2_irq(unsigned int irq)
 {
-	int offset=irq-INTC2_FIRST_IRQ;
+	int irq_offset = irq - INTC2_FIRST_IRQ;
+	int msk_shift, msk_offset;
 
-	// Sanity check
-	if(offset<0 || offset>=NR_INTC2_IRQS) return;
+	/* Sanity check */
+	if((irq_offset<0) || (irq_offset>=NR_INTC2_IRQS))
+		return;
 
-	ctrl_outl(intc2_data[offset].mask,
-		  intc2_data[offset].addr+INTC2_INTMSKCLR_OFFSET);
+	msk_shift = intc2_data[irq_offset].msk_shift;
+	msk_offset = intc2_data[irq_offset].msk_offset;
 
+	ctrl_outl(1<<msk_shift,
+		  INTC2_BASE+INTC2_INTMSKCLR_OFFSET+msk_offset);
 }
 
 static void mask_and_ack_intc2(unsigned int irq)
@@ -94,28 +100,50 @@
 {
 	if (!(irq_desc[irq].status & (IRQ_DISABLED|IRQ_INPROGRESS)))
 		enable_intc2_irq(irq);
-}
 
-void make_intc2_irq(unsigned int irq, unsigned int addr, 
-		    unsigned int group,int pos, int priority)
+#ifdef CONFIG_CPU_SUBTYPE_ST40
+	if (intc2_data[irq - INTC2_FIRST_IRQ].clear_irq)
+		intc2_data[irq - INTC2_FIRST_IRQ].clear_irq (irq);
+#endif
+}
+
+/*
+ * Setup an INTC2 style interrupt.
+ * NOTE: Unlike IPR interrupts, parameters are not shifted by this code,
+ * allowing the use of the numbers straight out of the datasheet.
+ * For example:
+ *    PIO1 which is INTPRI00[19,16] and INTMSK00[13]
+ * would be:               ^     ^             ^  ^
+ *                         |     |             |  |
+ *    make_intc2_irq(84,   0,   16,            0, 13);
+ */
+void make_intc2_irq(unsigned int irq,
+		    unsigned int ipr_offset, unsigned int ipr_shift,
+		    unsigned int msk_offset, unsigned int msk_shift,
+		    unsigned int priority)
 {
-	int offset=irq-INTC2_FIRST_IRQ;
-	unsigned flags,val;
+	int irq_offset = irq - INTC2_FIRST_IRQ;
+	unsigned int flags;
+	unsigned long ipr;
 
-	if(offset<0 || offset>=NR_INTC2_IRQS) {
+	if((irq_offset<0) || (irq_offset>=NR_INTC2_IRQS))
 		return;
-	}
+
 
 	disable_irq_nosync(irq);
-	/* Fill the data we need */
-	intc2_data[offset].addr=addr;
-	intc2_data[offset].mask=1<<pos;
-		
+
+	intc2_data[irq_offset].msk_offset = msk_offset;
+	intc2_data[irq_offset].msk_shift  = msk_shift;
+#ifdef CONFIG_CPU_SUBTYPE_ST40
+	intc2_data[irq_offset].clear_irq = NULL;
+#endif
+
 	/* Set the priority level */
 	save_and_cli(flags);
-	val=ctrl_inl(addr+INTC2_INTPRI_OFFSET);
-	val|=(priority)<< (group<<4);
-	ctrl_outl(val,addr+INTC2_INTPRI_OFFSET);
+	ipr=ctrl_inl(INTC2_BASE+INTC2_INTPRI_OFFSET+ipr_offset);
+	ipr&=~(0xf<<ipr_shift);
+	ipr|=(priority)<<ipr_shift;
+	ctrl_outl(ipr, INTC2_BASE+INTC2_INTPRI_OFFSET+ipr_offset);
 	restore_flags(flags);
 
 	irq_desc[irq].handler=&intc2_irq_type;
@@ -123,5 +151,70 @@
 	disable_intc2_irq(irq);
 }
 
+#ifdef CONFIG_CPU_SUBTYPE_ST40
+
+struct intc2_init {
+	unsigned short irq;
+	unsigned char ipr_offset, ipr_shift;
+	unsigned char msk_offset, msk_shift;
+};
+
+static struct intc2_init intc2_init_data[]  __initdata = {
+	{64,  0,  0, 0,  0},	/* PCI serr */
+	{65,  0,  4, 0,  1},	/* PCI err */
+	{66,  0,  4, 0,  2},	/* PCI ad */
+	{67,  0,  4, 0,  3},	/* PCI pwd down */
+	{72,  0,  8, 0,  5},	/* DMAC INT0 */
+	{73,  0,  8, 0,  6},	/* DMAC INT1 */
+	{74,  0,  8, 0,  7},	/* DMAC INT2 */
+	{75,  0,  8, 0,  8},	/* DMAC INT3 */
+	{76,  0,  8, 0,  9},	/* DMAC INT4 */
+	{78,  0,  8, 0, 11},	/* DMAC ERR */
+	{80,  0, 12, 0, 12},	/* PIO0 */
+	{84,  0, 16, 0, 13},	/* PIO1 */
+	{88,  0, 20, 0, 14},	/* PIO2 */
+	{112, 4,  0, 4,  0},	/* Mailbox */
+#ifdef CONFIG_CPU_SUBTYPE_ST40GX1
+	{116, 4,  4, 4,  4},	/* SSC0 */
+	{120, 4,  8, 4,  8},	/* IR Blaster */
+	{124, 4, 12, 4, 12},	/* USB host */
+	{128, 4, 16, 4, 16},	/* Video processor BLITTER */
+	{132, 4, 20, 4, 20},	/* UART0 */
+	{134, 4, 20, 4, 22},	/* UART2 */
+	{136, 4, 24, 4, 24},	/* IO_PIO0 */
+	{140, 4, 28, 4, 28},	/* EMPI */
+	{144, 8,  0, 8,  0},	/* MAFE */
+	{148, 8,  4, 8,  4},	/* PWM */
+	{152, 8,  8, 8,  8},	/* SSC1 */
+	{156, 8, 12, 8, 12},	/* IO_PIO1 */
+	{160, 8, 16, 8, 16},	/* USB target */
+	{164, 8, 20, 8, 20},	/* UART1 */
+	{168, 8, 24, 8, 24},	/* Teletext */
+	{172, 8, 28, 8, 28},	/* VideoSync VTG */
+	{173, 8, 28, 8, 29},	/* VideoSync DVP0 */
+	{174, 8, 28, 8, 30},	/* VideoSync DVP1 */
+#endif
+};
+
+void __init init_IRQ_intc2(void)
+{
+	struct intc2_init *p;	
+
+	for (p = intc2_init_data;
+	     p<intc2_init_data+ARRAY_SIZE(intc2_init_data);
+	     p++) {
+		make_intc2_irq(p->irq, p->ipr_offset, p->ipr_shift,
+			       p-> msk_offset, p->msk_shift, 13);
+	}
+}
+
+/* Adds a termination callback to the interrupt */
+void intc2_add_clear_irq(int irq, int (*fn)(int))
+{
+	if (irq < INTC2_FIRST_IRQ)
+		return;
 
+	intc2_data[irq - INTC2_FIRST_IRQ].clear_irq = fn;
+}
 
+#endif /* CONFIG_CPU_SUBTYPE_ST40 */
Index: arch/sh/kernel/irq_ipr.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/irq_ipr.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/irq_ipr.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/irq_ipr.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,15 +1,16 @@
-/* $Id: irq_ipr.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+/* $Id: irq_ipr.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *
  * linux/arch/sh/kernel/irq_ipr.c
  *
  * Copyright (C) 1999  Niibe Yutaka & Takeshi Yaegashi
  * Copyright (C) 2000  Kazumoto Kojima
+ * Copyright (C) 2003 Takashi Kusuda <kusuda-takashi@hitachi-ul.co.jp>
  *
  * Interrupt handling for IPR-based IRQ.
  *
  * Supported system:
  *	On-chip supporting modules (TMU, RTC, etc.).
- *	On-chip supporting modules for SH7709/SH7709A/SH7729.
+ *	On-chip supporting modules for SH7300/SH7709/SH7709A/SH7729.
  *	Hitachi SolutionEngine external I/O:
  *		MS7709SE01, MS7709ASE01, and MS7750SE01
  *
@@ -88,7 +89,8 @@
 {
 	disable_ipr_irq(irq);
 
-#if defined(CONFIG_CPU_SUBTYPE_SH7707) || defined(CONFIG_CPU_SUBTYPE_SH7709)
+#if defined(CONFIG_CPU_SUBTYPE_SH7300) || defined(CONFIG_CPU_SUBTYPE_SH7707) || \
+    defined(CONFIG_CPU_SUBTYPE_SH7709)
 	/* This is needed when we use edge triggered setting */
 	/* XXX: Is it really needed? */
 	if (IRQ0_IRQ <= irq && irq <= IRQ5_IRQ) {
@@ -196,7 +198,10 @@
 #endif
 
 	make_ipr_irq(TIMER_IRQ, TIMER_IPR_ADDR, TIMER_IPR_POS, TIMER_PRIORITY);
+
+#if defined(CONFIG_SH_RTC)
 	make_ipr_irq(RTC_IRQ, RTC_IPR_ADDR, RTC_IPR_POS, RTC_PRIORITY);
+#endif
 
 #ifdef SCI_ERI_IRQ
 	make_ipr_irq(SCI_ERI_IRQ, SCI_IPR_ADDR, SCI_IPR_POS, SCI_PRIORITY);
@@ -211,6 +216,10 @@
 	make_ipr_irq(SCIF1_TXI_IRQ, SCIF1_IPR_ADDR, SCIF1_IPR_POS, SCIF1_PRIORITY);
 #endif
 
+#if defined(CONFIG_CPU_SUBTYPE_SH7300)
+	make_ipr_irq(SCIF0_IRQ, SCIF0_IPR_ADDR, SCIF0_IPR_POS, SCIF0_PRIORITY);
+#endif
+
 #ifdef SCIF_ERI_IRQ
 	make_ipr_irq(SCIF_ERI_IRQ, SCIF_IPR_ADDR, SCIF_IPR_POS, SCIF_PRIORITY);
 	make_ipr_irq(SCIF_RXI_IRQ, SCIF_IPR_ADDR, SCIF_IPR_POS, SCIF_PRIORITY);
@@ -225,7 +234,8 @@
 	make_ipr_irq(IRDA_TXI_IRQ, IRDA_IPR_ADDR, IRDA_IPR_POS, IRDA_PRIORITY);
 #endif
 
-#if defined(CONFIG_CPU_SUBTYPE_SH7707) || defined(CONFIG_CPU_SUBTYPE_SH7709)
+#if defined(CONFIG_CPU_SUBTYPE_SH7300) || defined(CONFIG_CPU_SUBTYPE_SH7707) || \
+    defined(CONFIG_CPU_SUBTYPE_SH7709)
 	/*
 	 * Initialize the Interrupt Controller (INTC)
 	 * registers to their power on values
@@ -242,6 +252,7 @@
 	make_ipr_irq(IRQ3_IRQ, IRQ3_IPR_ADDR, IRQ3_IPR_POS, IRQ3_PRIORITY);
 	make_ipr_irq(IRQ4_IRQ, IRQ4_IPR_ADDR, IRQ4_IPR_POS, IRQ4_PRIORITY);
 	make_ipr_irq(IRQ5_IRQ, IRQ5_IPR_ADDR, IRQ5_IPR_POS, IRQ5_PRIORITY);
+#if !defined(CONFIG_CPU_SUBTYPE_SH7300)
 	make_ipr_irq(PINT0_IRQ, PINT0_IPR_ADDR, PINT0_IPR_POS, PINT0_PRIORITY);
 	make_ipr_irq(PINT8_IRQ, PINT8_IPR_ADDR, PINT8_IPR_POS, PINT8_PRIORITY);
 	enable_ipr_irq(PINT0_IRQ);
@@ -260,16 +271,23 @@
 		else if(i & 0x40) pint_map[i] = 6;
 		else if(i & 0x80) pint_map[i] = 7;
 	}
-#endif /* CONFIG_CPU_SUBTYPE_SH7707 || CONFIG_CPU_SUBTYPE_SH7709 */
+#endif
+#endif /* CONFIG_CPU_SUBTYPE_SH7300 || CONFIG_CPU_SUBTYPE_SH7707 || CONFIG_CPU_SUBTYPE_SH7709 */
+
+#ifdef CONFIG_CPU_SUBTYPE_ST40
+	init_IRQ_intc2();
+#endif
 
 	/* Perform the machine specific initialisation */
 	if (sh_mv.mv_init_irq != NULL) {
 		sh_mv.mv_init_irq();
 	}
 }
-#if defined(CONFIG_CPU_SUBTYPE_SH7707) || defined(CONFIG_CPU_SUBTYPE_SH7709)
+#if defined(CONFIG_CPU_SUBTYPE_SH7300) || defined(CONFIG_CPU_SUBTYPE_SH7707) || \
+    defined(CONFIG_CPU_SUBTYPE_SH7709)
 int ipr_irq_demux(int irq)
 {
+#if !defined(CONFIG_CPU_SUBTYPE_SH7300)
 	unsigned long creg, dreg, d, sav;
 
 	if(irq == PINT0_IRQ)
@@ -304,6 +322,7 @@
 		if(d == 0) return irq;
 		return PINT_IRQ_BASE + 8 + pint_map[d];
 	}
+#endif
 	return irq;
 }
 #endif
Index: arch/sh/kernel/led_se.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/led_se.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/led_se.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/led_se.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -10,7 +10,14 @@
  */
 
 #include <linux/config.h>
+
+#ifdef CONFIG_SH_7751_SOLUTION_ENGINE
+#include <asm/hitachi_7751se.h>
+#elif defined(CONFIG_SH_MOBILE_SOLUTION_ENGINE)
+#include <asm/hitachi_shmse.h>
+#else
 #include <asm/hitachi_se.h>
+#endif
 
 static void mach_led(int position, int value)
 {
Index: arch/sh/kernel/mach_7751se.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/mach_7751se.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/mach_7751se.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/mach_7751se.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -18,7 +18,7 @@
 
 #include <asm/io_7751se.h>
 
-void heartbeat_7751se(void);
+void heartbeat_se(void);
 void setup_7751se(void);
 void init_7751se_IRQ(void);
 
@@ -67,7 +67,7 @@
 	mv_init_arch:		setup_7751se,
 	mv_init_irq:		init_7751se_IRQ,
 #ifdef CONFIG_HEARTBEAT
-	mv_heartbeat:		heartbeat_7751se,
+	mv_heartbeat:		heartbeat_se,
 #endif
 
 	mv_rtc_gettimeofday:	sh_rtc_gettimeofday,
Index: arch/sh/kernel/mach_dc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/mach_dc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/mach_dc.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/mach_dc.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- *	$Id: mach_dc.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ *	$Id: mach_dc.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *	SEGA Dreamcast machine vector
  */
 
Index: arch/sh/kernel/pci-dc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/pci-dc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/pci-dc.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/pci-dc.c	4 Aug 2004 01:26:12 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- $	$Id: pci-dc.c,v 1.1 2004/07/22 19:48:57 joff Exp $
+ $	$Id: pci-dc.c,v 1.2 2004/08/04 01:26:12 joff Exp $
  *	Dreamcast PCI: Supports SEGA Broadband Adaptor only.
  */
 
Index: arch/sh/kernel/pci-sh7751.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/arch/sh/kernel/pci-sh7751.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- arch/sh/kernel/pci-sh7751.c	22 Jul 2004 19:48:57 -0000	1.1
+++ arch/sh/kernel/pci-sh7751.c	4 Aug 2004 01:26:13 -0000	1.2
@@ -38,8 +38,6 @@
  * Direct access to PCI hardware...
  */
 
-#ifdef CONFIG_PCI_DIRECT
-
 
 #define CONFIG_CMD(dev, where) (0x80000000 | (dev->bus->number << 16) | (dev->devfn << 8) | (where & ~3))
 
@@ -202,8 +200,10 @@
 	unsigned int tmp, id;
 
 	/* check for SH7751 hardware */
-	id = (SH7751_DEVICE_ID << 16) | SH7751_VENDOR_ID;
-	if(inl(SH7751_PCIREG_BASE+SH7751_PCICONF0) != id) {
+	id = inl(SH7751_PCIREG_BASE + SH7751_PCICONF0);
+
+	if ((id != ((SH7751_DEVICE_ID << 16) | SH7751_VENDOR_ID)) &&
+	    (id != ((SH7751R_DEVICE_ID << 16) | SH7751_VENDOR_ID))) {
 		PCIDBG(2,"PCI: This is not an SH7751\n");
 		return NULL;
 	}
@@ -226,20 +226,6 @@
 	return NULL;
 }
 
-#endif
-
-/*
- * BIOS32 and PCI BIOS handling.
- * 
- * The BIOS version of the pci functions is not yet implemented but it is left
- * in for completeness.  Currently an error will be generated at compile time. 
- */
- 
-#ifdef CONFIG_PCI_BIOS
-
-#error PCI BIOS is not yet supported on SH7751
-
-#endif /* CONFIG_PCI_BIOS */
 
 /***************************************************************************************/
 
@@ -342,16 +328,9 @@
 	struct pci_ops *dir = NULL;
 
 	PCIDBG(1,"PCI: Starting intialization.\n");
-#ifdef CONFIG_PCI_BIOS
-	if ((pci_probe & PCI_PROBE_BIOS) && ((bios = pci_find_bios()))) {
-		pci_probe |= PCI_BIOS_SORT;
-		pci_bios_present = 1;
-	}
-#endif
-#ifdef CONFIG_PCI_DIRECT
+
 	if (pci_probe & PCI_PROBE_CONF1 )
 		dir = pci_check_direct();
-#endif
 	if (dir) {
 		pci_root_ops = dir;
 	    if(!pcibios_init_platform())
@@ -372,11 +351,6 @@
 	pci_fixup_irqs(pcibios_swizzle, pcibios_lookup_irq);
 	pcibios_fixup_peer_bridges();
 	pcibios_resource_survey();
-
-#ifdef CONFIG_PCI_BIOS
-	if ((pci_probe & PCI_BIOS_SORT) && !(pci_probe & PCI_NO_SORT))
-		pcibios_sort();
-#endif
 }
 
 char * __init pcibios_setup(char *str)
@@ -384,29 +358,10 @@
 	if (!strcmp(str, "off")) {
 		pci_probe = 0;
 		return NULL;
-	}
-#ifdef CONFIG_PCI_BIOS
-	else if (!strcmp(str, "bios")) {
-		pci_probe = PCI_PROBE_BIOS;
-		return NULL;
-	} else if (!strcmp(str, "nobios")) {
-		pci_probe &= ~PCI_PROBE_BIOS;
-		return NULL;
-	} else if (!strcmp(str, "nosort")) {
-		pci_probe |= PCI_NO_SORT;
-		return NULL;
-	} else if (!strcmp(str, "biosirq")) {
-		pci_probe |= PCI_BIOS_IRQ_SCAN;
-		return NULL;
-	}
-#endif
-#ifdef CONFIG_PCI_DIRECT
-	else if (!strcmp(str, "conf1")) {
+	} else if (!strcmp(str, "conf1")) {
 		pci_probe = PCI_PROBE_CONF1 | PCI_NO_CHECKS;
 		return NULL;
-	}
-#endif
-	else if (!strcmp(str, "rom")) {
+	} else if (!strcmp(str, "rom")) {
 		pci_probe |= PCI_ASSIGN_ROMS;
 		return NULL;
 	} else if (!strncmp(str, "lastbus=", 8)) {
